> For the complete documentation index, see [llms.txt](https://docs.tonic.ai/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.tonic.ai/fabricate/data-masking/masking-generators-builtin.md).

# Built-in masking generators

Based on the scan results, Fabricate assigns a masking generator to each column. You can use the Data Agent to change the generator assignment.

Fabricate uses the following built-in masking generators.

<table><thead><tr><th valign="top">Generator name</th><th valign="top">Generator identifier</th><th valign="top">How it works</th></tr></thead><tbody><tr><td valign="top">Fake street address</td><td valign="top"><code>address</code></td><td valign="top">Generates a realistic street number, street name, or postal code.</td></tr><tr><td valign="top">Adjusted age</td><td valign="top"><code>age</code></td><td valign="top">Changes the age by whole years based on the date birth value for the record.</td></tr><tr><td valign="top">Shuffled category</td><td valign="top"><code>categorical</code></td><td valign="top"><p>Replaces the value with a value from the original data.</p><p></p><p>Preserves the original distribution of the values.</p></td></tr><tr><td valign="top">Fixed value</td><td valign="top"><code>constant</code></td><td valign="top">Replaces all of the values with a single constant value that you provide.</td></tr><tr><td valign="top">Copied unchanged</td><td valign="top"><code>copy</code></td><td valign="top"><p>Passes the original value through to the destination database. </p><p></p><p>The value remains unchanged.</p><p></p><p>Columns that are not identified as sensitive automatically use the copy method.</p></td></tr><tr><td valign="top">Fake credit card number</td><td valign="top"><code>credit_card</code> </td><td valign="top">Generates a credit card account number that passes the Luhn algorithm and has a realistic bank identification number.</td></tr><tr><td valign="top">Shifted date</td><td valign="top"><code>date_shift</code></td><td valign="top"><p>Shifts a datetime value.</p><p></p><p>Maintains the format of the original value.</p></td></tr><tr><td valign="top">Fake email address</td><td valign="top"><code>email</code></td><td valign="top">Generates a realistic email address.</td></tr><tr><td valign="top">Filler text</td><td valign="top"><code>free_text</code> </td><td valign="top"><p>Replaces free text with filler sentences.</p><p></p><p>Note that this method is deprecated. Instead, Fabricate uses the scramble method to replace free text content.</p></td></tr><tr><td valign="top">Hashed value</td><td valign="top"><code>hash</code></td><td valign="top">Generates a hex digest from the source value.</td></tr><tr><td valign="top">Masked JSON fields</td><td valign="top"><code>json</code></td><td valign="top"><p>Within the JSON, replaces the individual path values based on their categories.</p><p></p><p>For example, when the JSON contains a name value, Fabricate uses the <code>person_name</code> method to replace it.</p></td></tr><tr><td valign="top">Fake place</td><td valign="top"><code>location</code></td><td valign="top">Replaces the value with a city, state, postal code, or country.</td></tr><tr><td valign="top">Fake national ID</td><td valign="top"><code>national_id</code></td><td valign="top"><p>Replaces the value with a valid identifier based on the country.</p><p></p><p>For example, this method can produce valid United States Social Security numbers.</p></td></tr><tr><td valign="top">Emptied (NULL)</td><td valign="top"><code>null</code></td><td valign="top">Replaces the value with a SQL NULL value.</td></tr><tr><td valign="top">Slightly changed number</td><td valign="top"><code>number_jitter</code> </td><td valign="top"><p>Replaces a numeric value.</p><p></p><p>To create the new value, Fabricate uses numeric perturbation within bounds.</p></td></tr><tr><td valign="top">Fake person name</td><td valign="top"><code>person_name</code></td><td valign="top"><p>Replaces the value with a realistic name value.</p><p></p><p>Fabricate selects name values from its reference datasets of name values.</p></td></tr><tr><td valign="top">Fake phone number</td><td valign="top"><code>phone</code></td><td valign="top">Replaces the value with a valid generated telephone number.</td></tr><tr><td valign="top">Scrambled characters</td><td valign="top"><code>scramble</code></td><td valign="top"><p>Replaces the letters and digits in a text string.</p><p></p><p>Keeps the same overall shape of the string.</p></td></tr><tr><td valign="top">AI-written replacement text</td><td valign="top"><code>synthesize</code></td><td valign="top">Generates text that an AI agent can read.</td></tr><tr><td valign="top">Masked XML fields</td><td valign="top"><code>xml</code></td><td valign="top"><p>Within the XML, replaces the individual path values based on their category.</p><p></p><p>For example, if the XML includes a name value, then Fabricate uses the <code>person_name</code> method to replace it.</p></td></tr></tbody></table>


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.tonic.ai/fabricate/data-masking/masking-generators-builtin.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
